<template>
    <div class="q-mt-md-xl q-mt-lg-lg q-px-lg-xl q-px-md-none q-px-xs-lg">
        <div
            class="col-12 col-md-12 col-lg-11 font-18 text-black q-mt-lg"
            v-if="state.currentPage == 'default'"
        >
            <div class="row">
                <div class="col-12 col-sm-5 col-md-5 col-lg-4">
                    <q-input
                        outlined
                        bottom-slots
                        v-model="search"
                        :label="$t('preference.searchRoles')"
                        :loading="state.loadingState"
                        debounce="500"
                        bg-color="transparent"
                        clearable
                        dense
                        class="border-radius-10 font-14"
                    >
                        <template v-slot:prepend>
                            <q-icon name="search" class="text-5B9ADD" />
                        </template>
                    </q-input>
                </div>
                <div
                    class="
                        col-12 col-sm-7 col-md-7 col-lg-8
                        q-pl-lg-lg q-pl-md-lg q-pl-sm-lg q-pl-xs-none
                    "
                    v-if="permissions.role?.create"
                >
                    <q-btn
                        class="
                            border-radius-10
                            q-px-lg
                            item-center
                            font-16
                            button-createLabel
                        "
                        no-caps
                        text-color="white"
                        :label="$t('button.createRoles')"
                        @click="selectCurrentPage('role-create')"
                    />
                    <span
                        class="
                            roles-number
                            q-pl-md
                            font-18
                            helvetica-neue-medium
                        "
                    >
                        {{ $t('preference.roles') }} - {{ state.roles.length }}
                    </span>
                </div>
            </div>
            <div class="row">
                <div
                    class="
                        col-xs-12 col-sm-3 col-md-2 col-lg-2
                        q-my-sm q-mr-md q-my-md-sm q-my-sm-sm
                    "
                    v-for="(role, index) in state.roles"
                    :key="'role-' + index"
                >
                    <q-card
                        flat
                        bordered
                        class="my-card border-radius-10"
                        :style="{
                            backgroundColor: role?.color
                        }"
                    >
                        <q-card-section class="q-pa-xs">
                            <div class="row items-center q-pl-md q-pl-xs-sm">
                                <div class="q-mt-sm">
                                    <p class="roles-name text-white font-14">
                                        {{ role?.name }}
                                    </p>
                                </div>
                                <div class="roles-option-container">
                                    <q-btn
                                        size="lg"
                                        color="white"
                                        round
                                        flat
                                        icon="more_horiz"
                                        v-if="
                                            permissions.role.update ||
                                            permissions.role.delete
                                        "
                                    >
                                        <q-menu
                                            class="label-menu"
                                            fit
                                            anchor="bottom right"
                                            self="center middle"
                                            auto-close
                                        >
                                            <q-list
                                                class="label-buttons-container"
                                            >
                                                <q-item
                                                    class="
                                                        button-padding
                                                        q-pa-none
                                                    "
                                                    clickable
                                                    @click="editRole(role)"
                                                >
                                                    <q-item-section avatar>
                                                        <q-icon
                                                            color="primary"
                                                            name="edit"
                                                        />
                                                    </q-item-section>
                                                    <q-item-section
                                                        class="
                                                            label-buttons
                                                            text-4586E1
                                                        "
                                                    >
                                                        {{ $t('button.edit') }}
                                                    </q-item-section>
                                                </q-item>
                                                <q-item
                                                    v-if="role?.totalMember < 1"
                                                    class="
                                                        button-padding
                                                        q-pa-none
                                                    "
                                                    clickable
                                                    @click="
                                                        removeRole(role?.id)
                                                    "
                                                >
                                                    <q-item-section avatar>
                                                        <q-icon
                                                            class="remove-btn"
                                                            name="remove_circle"
                                                        />
                                                    </q-item-section>
                                                    <q-item-section
                                                        class="
                                                            label-buttons
                                                            text-FA6767
                                                        "
                                                    >
                                                        {{
                                                            $t('button.remove')
                                                        }}
                                                    </q-item-section>
                                                </q-item>
                                            </q-list>
                                        </q-menu>
                                    </q-btn>
                                </div>
                            </div>
                            <div class="row justify-end items-center q-pr-sm">
                                <span class="q-pa-xs text-white font-18">
                                    {{
                                        role?.totalMember
                                            ? role?.totalMember
                                            : 0
                                    }}
                                </span>
                                <q-icon color="white" size="sm" name="person" />
                            </div>
                        </q-card-section>
                    </q-card>
                </div>
            </div>
        </div>

        <div v-else-if="state.currentPage == 'role-create'">
            <create-role :role="state.selectedRole" @update-page="updatePage" />
        </div>
        <div v-else-if="state.currentPage == 'role-update'">
            <update-role
                :role="state.selectedRole"
                @update-confirm="updateConfirm"
                @update-page="updatePage"
            />
        </div>
    </div>
</template>

<script lang="ts">
import { useStore } from 'src/store';
import { mapGetters } from 'vuex';
import {
    defineComponent,
    ref,
    computed,
    watch,
    reactive,
    onMounted
} from 'vue';
import CreateRole from '../roles/CreateRole.vue';
import UpdateRole from '../roles/UpdateRole.vue';

export default defineComponent({
    name: 'RolesList',
    components: {
        CreateRole,
        UpdateRole
    },
    computed: {
        ...mapGetters({
            business: 'business/getBusiness',
            permissions: 'role/getPermissions'
        })
    },
    setup() {
        const store = useStore();

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const search = ref('');
        let state = reactive({
            currentPage: 'default',
            roles: computed(() => {
                return store.state.role.role;
            }),
            loadingState: ref(false),
            colors: [
                {
                    id: 1,
                    name: '#4586E1'
                },
                {
                    id: 2,
                    name: '#8A6FF0'
                },
                {
                    id: 3,
                    name: '#FF6700'
                },
                {
                    id: 4,
                    name: '#46C883'
                },
                {
                    id: 5,
                    name: '#FFBB46'
                },
                {
                    id: 6,
                    name: '#FA6EAD'
                },
                {
                    id: 7,
                    name: '#29C5CE'
                },
                {
                    id: 8,
                    name: '#F09253'
                },
                {
                    id: 9,
                    name: '#F4656B'
                },
                {
                    id: 10,
                    name: '#7393C2'
                },
                {
                    id: 11,
                    name: '#C784AF'
                },
                {
                    id: 12,
                    name: '#00949D'
                }
            ],
            icons: [
                {
                    id: 1,
                    name: 'nightlight'
                },
                {
                    id: 2,
                    name: 'people'
                },
                {
                    id: 3,
                    name: 'campaign'
                }
            ],
            selectedRole: {
                roleId: '',
                name: '',
                permissions: [] as any,
                color: ''
            },
            roleName: ref(''),
            selectedPermission: [] as any,
            selectedColor: { name: '#666B72' }
        });

        /* store.watch(
            (state) => state.business.businessID,
            () => {
                alert('woot');
                getRoles('');
            }
        ); */

        watch(search, (currentValue) => {
            if (currentValue) {
                getRoles(currentValue);
            } else {
                state.loadingState = false;
                getRoles('');
            }
        });

        const selectCurrentPage = (page: string) => {
            state.currentPage = page;
        };

        const updateConfirm = (value: any) => {
            const findIndex = state.roles.findIndex(
                (element: any) => element.id == value.roleId
            );
            if (findIndex != -1) {
                state.roles[findIndex].permissions = value.permissions;
            }
        };

        const updatePage = (value: any) => {
            state.currentPage = value;
        };

        const editRole = (role: any) => {
            state.selectedRole.roleId = role.id;
            state.selectedRole.name = role.name;
            state.selectedRole.color = role.color;
            state.selectedRole.permissions = role.permissions;
            state.roleName = role.name;
            state.selectedColor.name = role.color;
            state.selectedPermission = role.permission;

            state.currentPage = 'role-update';
        };

        const getRoles = async (search?: string) => {
            // get role if authorized members
            if (store.state.role.permissions.role?.list) {
                const result = await store.dispatch(
                    'role/getList',
                    {
                        keyword: search
                    },
                    {
                        root: true
                    }
                );

                if (result) {
                    state.roles = result.roles;
                }
            }
        };

        const removeRole = async (id: any) => {
            if (store.state.role.permissions.role?.delete) {
                await store.dispatch('role/delete', {
                    roleId: id
                });
            }
        };

        onMounted(getRoles);

        return {
            state,
            getRoles,
            selectCurrentPage,
            editRole,
            removeRole,
            updateConfirm,
            updatePage,
            selectedBusinessId,
            search
        };
    }
});
</script>
